#############################
#
#          SoloCartes
#
# Copyright 2008 Newmagic
#
#    This file is part of SoloCartes.
#
#    You can redistribute and/or modify
#    this software under the terms of the
#    Creative Commons  Attribution-NonCommercial-ShareAlike 3.0 Legal Code
#
#    See COPYING file(s) join to the distribution and/or
#    http://creativecommons.org/licenses/by-nc-sa/3.0/legalcode
#
#############################

global PARAM

set PARAM(rep) [info script]
set PARAM(rep) [file dirname $PARAM(rep)]
cd $PARAM(rep)

source "SoloCartes_initJeux.tcl"

global nbCartesDistrib
set nbCartesDistrib 1

global conditionSupprime
set conditionSupprime "VF" ;# ici, valeur OU famille

global ligne
set ligne [list]

global LISTE_VARS_OPTIONS_JEU
set LISTE_VARS_OPTIONS_JEU [list nbCartesDistrib conditionSupprime]

global LISTE_VARS_SAUV_PARTIE
set LISTE_VARS_SAUV_PARTIE [list paquet ligne indDerniereCarteDistribuee nbCartes nbCartesDistrib conditionSupprime]

global jeuCourant
set jeuCourant "EntreDeux"
chargerOptionsJeu

array set imagesFaces [list]


global paquet


proc attraperCarte {indCarte x y} {
  global imgCartes
  global paquet
  global ligne
  global PAQUET_POURC_X
  global PAQUET_POURC_Y
  global largImages
  global indDerniereCarteDistribuee
  global nbCartes
  global nbCartesDistrib
  global txt

  set liste [.frmJeu.cnv coords $imgCartes($indCarte)]
  set x_carte [lindex $liste 0]
  set y_carte [lindex $liste 1]
  if {$paquet($indCarte,distribuee)} {
    if {[peutDisparaitre $indCarte]} {
memoriserCoupAnnuler 2
        enleverCarte $indCarte
        gagner 1
    } ;# On ne fait rien
  } else {
    if {[pourcCoordX $x_carte] == $PAQUET_POURC_X && [pourcCoordY $y_carte] == $PAQUET_POURC_Y} {
      # clic sur paquet
effacerCoupAnnuler
      distribuer
    }
  }
  if {[termine]} {
    verifierScore
    incrementerStats "$txt(STAT_NB_GAGNE)"
    proposerRejouer
  }
}

proc peutDisparaitre {indCarte} {
  global ligne
  global paquet
  global conditionSupprime

  set continuer true
  set trouve false
  set indLigne 1
  if {$paquet($indCarte) != ""} {
    # La carte n'a pas encore t enleve
    set rang [lsearch $ligne $indCarte]
    if {$rang > 0 && $rang < [expr {[llength $ligne] - 1}]} {
      # Ce n'est pas la premire ni la dernire => on regarde si la prcdente et la suivante vrifient les conditions :
      set carte1 [lindex $ligne [expr {$rang - 1}]]
      set carte2 [lindex $ligne [expr {$rang + 1}]]
      set memeValeur false
      set memeFamille false
      if {[valeurCarte $carte1] == [valeurCarte $carte2]} {
        set memeValeur true
      }
      if {[famillePCKT $carte1] == [famillePCKT $carte2]} {
        set memeFamille true
      }
      if {$conditionSupprime == "V"} {
        # il faut qu'elles soient de mme valeur :
        set trouve $memeValeur
      }
      if {$conditionSupprime == "F"} {
        # il faut qu'elles soient de mme famille :
        set trouve $memeFamille
      }
      if {$conditionSupprime == "VF" && ($memeFamille || $memeValeur)} {
        # il faut qu'elles soient de mme famille OU de mme valeur :
        set trouve true
      }
    }
  }
  return $trouve
}


proc enleverCarte {indCarte} {
  global imgCartes
  global paquet
  global indDerniereCarteDistribuee
  global ligne
  
  set rang [lsearch $ligne $indCarte]
  if {$rang >= 0} {
#    set rangSuiv [expr {$rang + 1}]
    set rangDern [expr {[llength $ligne] - 1}]
    for {set i $rangDern} {$i >= $rang} {incr i -1} {
      set indCartePrec [lindex $ligne [expr {$i - 1}]]
      set liste [.frmJeu.cnv coords $imgCartes($indCartePrec)]
      set x_carte [lindex $liste 0]
      set y_carte [lindex $liste 1]
      .frmJeu.cnv coords $imgCartes([lindex $ligne $i]) [list $x_carte $y_carte]
    }
    incr rang -1 ;# En ralit, on enlve la prcdente
    set indCarte [lindex $ligne $rang]
    set ligne [lreplace $ligne $rang $rang]
    catch {.frmJeu.cnv delete $imgCartes($indCarte)}
    set paquet($indCarte) ""
#effacerCoupAnnuler
  }
}

proc distribuer {{jusqua ""}} {
  global indDerniereCarteDistribuee
  global paquet
  global nbCartesDistrib
  global nbCartes
  global PAQUET_POURC_X
  global PAQUET_POURC_Y
  global largImages
  global imgCartes
  
  if {$jusqua == ""} {
    set jusqua $nbCartes
  }
  if {$indDerniereCarteDistribuee <= 0} {
    set indDerniereCarteDistribuee 1 ;# on passe direct  la 1
  } else {
    set i 1
    set prec $indDerniereCarteDistribuee
    #incr prec -1
    set prec [cartePrecDistribuee $prec]
#    while {$i < $nbCartesDistrib && $prec > 0} {
#      .frmJeu.cnv coords $imgCartes($prec) [list [coordX [expr {2 * $PAQUET_POURC_X + $largImages}]] [coordY $PAQUET_POURC_Y]]
#      incr i
#      incr prec -1
#      set prec [cartePrecDistribuee $prec]
#    }
  }
  for {set i 0} {$i < $nbCartesDistrib} {incr i} {
    set continuer true
    while {$continuer} {
      if {$indDerniereCarteDistribuee <= $jusqua} {
        if {(! $paquet($indDerniereCarteDistribuee,distribuee)) && $paquet($indDerniereCarteDistribuee) != ""} {
          set indCarte $indDerniereCarteDistribuee
          set paquet($indCarte,faceEnHaut) false
#          deplacerCarte $indCarte [coordX [expr {2 * $PAQUET_POURC_X + $largImages + 3 * $i}]] [coordY $PAQUET_POURC_Y]
          distribuerCarte $indCarte ;# [coordX [expr {2 * $PAQUET_POURC_X + $largImages + 3 * $i}]] [coordY $PAQUET_POURC_Y]
          retournerCarte $indCarte
          set paquet($indCarte,distribuee) true
          set continuer false
        } else {
          incr indDerniereCarteDistribuee
        }
      } else {
        set indDerniereCarteDistribuee $jusqua
        set continuer false
      }
    }
  }
}


proc bindingsCarte {indCarte} {
  global imgCartes

  .frmJeu.cnv bind $imgCartes($indCarte) <ButtonPress-1> "attraperCarte $indCarte %X %Y"

  .frmJeu.cnv bind $imgCartes($indCarte) <Double-ButtonPress-1> "attraperCarte $indCarte %X %Y"

}


proc cartePrecDistribuee {indCarte} {
  global paquet

  set continuer true
  set i $indCarte
  while {$continuer} {
    if {$paquet($i,distribuee) || $paquet($i) == ""} {
      incr i -1
      if {$i <= 0} {
        set i -1
        set continuer false
      }
    } else {
      set continuer false
    }
  }
  return $i
}

proc initLigne {} {
  global ligne

  unset ligne
  set ligne [list]
}

proc distribuerCartes {} {
}

proc distribuerCarte {indCarte {rang ""} {avecAnimation false}} {
  global ligne
  global paquet
  global PAQUET_POURC_X
  global PAQUET_POURC_Y
  global hautImages
  global largImages

  if {$rang == ""} {
    set rang [llength $ligne]
    lappend ligne $indCarte
  }
  # On distribue la carte au rang indiqu.
  # On doit pour cela calculer le nombre de cartes affichables en largeur de l'cran :
  set nbCartesAffichables [expr {100 / ($largImages + $PAQUET_POURC_X)}]
  # On en dduit l'emplacement de celle-ci :
  # En fait, on ajoute 1 au rang car le paquet occupe le premier emplacement :
  incr rang
  set indLigne [expr {int($rang / $nbCartesAffichables)}]
  set indCol [expr {$rang % $nbCartesAffichables}]
  # On doit poser la carte  l'emplacement correspondants :
  set xPourc [expr {$PAQUET_POURC_X + $indCol * ($largImages + $PAQUET_POURC_X) }]
  set yPourc [expr {$PAQUET_POURC_Y + $indLigne * ($hautImages + $PAQUET_POURC_Y) }]
  deplacerCarte $indCarte [coordX $xPourc] [coordY $yPourc] $avecAnimation
  set paquet($indCarte,distribuee) true
}

proc termine {} {
  global ligne
  global nbCartes
  global paquet
  global indDerniereCarteDistribuee
  
  if {$indDerniereCarteDistribuee == $nbCartes} {
    # Il ne reste plus de carte dans le paquet
    # Voyons s'il reste des cartes "enlevables" :
    set i 1 ;# Pas la peine de vrifier la premire : elle ne sera jamais enleve (car pas de prcdente)
    set continuer true
    while {$continuer} {
      if {$i < [llength $ligne]} {
        set indCarte [lindex $ligne $i]
        if {[peutDisparaitre $indCarte]} {
          set continuer false
        } else {
          incr i
        }
      } else {
        set continuer false
      }
    }
    if {$i < [llength $ligne]} {
      return false ;# Il reste encore au-moins une carte  enlever
    } else {
      return true
    }
  } else {
    return false
  }
}


proc initScoresStats {} {
global jeuCourant
  global conditionSupprime
  global typeScore
global titreScores
  global REP_HIGHSCORES
  global REP_STATS
  global txt

set titreScores "$txt($jeuCourant\,NOM)"
if {$conditionSupprime == "F"} {
  append titreScores " - $txt(EntreDeux,TXT_FAMILLE)"
}
if {$conditionSupprime == "V"} {
  append titreScores " - $txt(EntreDeux,TXT_VALEUR)"
}
if {$conditionSupprime == "VF"} {
  append titreScores " - $txt(EntreDeux,TXT_VALEUR_FAMILLE)"
}
set nomFicScores "$jeuCourant\_$conditionSupprime"
  chargerHighScores [file join $REP_HIGHSCORES "$nomFicScores\.txt"]
  chargerStats [file join $REP_STATS "$jeuCourant\.txt"]
}

proc majAfficheJeu {} {
  global ligne
  global nbLignes
  global paquet
  global nbCartes
  global indDerniereCarteDistribuee
  global nbCartesDistrib
  global PAQUET_POURC_X
  global PAQUET_POURC_Y
  global hautImages
  global nbPassagesPaquet
  global imgCartes

  initScoresStats
  initAffichage
#  set dernDistrib $indDerniereCarteDistribuee
#msgBox "$dernDistrib"

  set PAQUET_POURC_X 5
  set PAQUET_POURC_Y 5
  tracerRectangleCarte "paquet" [coordX $PAQUET_POURC_X] [coordY $PAQUET_POURC_Y]
 .frmJeu.cnv bind paquet <ButtonPress-1> "rempilerPaquet"
  for {set i $nbCartes} {$i >= 1} {incr i -1} {
#    if {$paquet($i) != ""} {
      placerCarte $i $PAQUET_POURC_X $PAQUET_POURC_Y [expr {! $paquet($i,faceEnHaut)}]
#    }
  }

  #  initColonnes $nbColonnes
  for {set i 1} {$i <= $nbCartes} {incr i} {
    set paquet($i,distribuee) false
    if {$paquet($i) == ""} {
      catch {.frmJeu.cnv delete $imgCartes($i)}
    }
  }
#  set indDerniereCarteDistribuee 0
    set rang 0
    #msgBox "$i : $colonnes($i,listeCartes)"
    foreach indCarte $ligne {
      if {$paquet($indCarte) != ""} {
        set paquet($indCarte,distribuee) true
        set faceEnHaut($indCarte) $paquet($indCarte,faceEnHaut)
        #    placerCarte $indCarte 110 110 true
        distribuerCarte $indCarte $rang
        set paquet($indCarte,faceEnHaut) $faceEnHaut($indCarte)
        montrerCarte $indCarte $paquet($indCarte,faceEnHaut)
      }
      incr rang
#      incr indDerniereCarteDistribuee
    }
#  for {set i 1} {$i <= $nbCartes} {incr i} {
#    if {$paquet($i) == ""} {
#      enleverCarte $i
#    }
#  }
  
  update
}

proc commencerPartie {} {
  global joueurs
  global SCORE_DE_DEPART
  global nbCartesDistrib
  global nbLignes
global jeuCourant
  global titreScores
  global txt
  
  initPartie $jeuCourant
  initScoresStats
  initAffichage
  melangerPaquet
  placerPaquet 5 5
  initLigne
  distribuerCartes
  majAfficheScore
  afficherFrame frmJeu
  incrementerStats "$txt(STAT_NB_PARTIES)"
}

global lanceAuto
if {$lanceAuto} {
commencerPartie
}