 # he-dialog.tcl
 # Version 0.6

 proc windowFit {top} {
	# This proc is used in other scripts, too.

	if {$::tcl_platform(os) eq {Windows CE}} {
		if {[info exists ::etcl::etcl]} {
			bind $top  <ConfigureRequest> {::etcl::autofit %W}
			bind $top <Expose> {::etcl::autofit %W}
			::etcl::autofit $top
		} else {
			wm geometry $top 240x[expr {320 - 51}]+0+0
		}
	} else {
		wm geometry $top 240x[expr {320 - 51}]+[expr {[winfo pointerx .] - 120}]+[expr {[winfo pointery .] - 135}]
	}
	return
 }
 if {[info exists ::etcl::etcl]} {
	#
	# tk_getOpenFile, tk_getSaveFile
	#

	option add  *__tk_filedialog.icons.canvas.background white

	# hot patch file tkfbox.tcl,v 1.55
	set body [split [info body ::tk::dialog::file::] "\n"]
	set changeA [list "\t# HE: Change the requester size to fit on pda" "\twindowFit \$w" {}]
	set changeB [list "\t# HE: To make the dialog window transient creates a title bar?!" "\t# (at least in etcl-8.4.12-pl7 and etcl-8.4.12-pl8)" "#[lindex $body 52]" "#[lindex $body 53]" "#[lindex $body 54]"]
	set body1 [join [concat [lrange $body 0 51] $changeB [lrange $body 55 end-20] $changeA [lrange $body end-19 end]] "\n"]
	proc ::tk::dialog::file:: {type args} $body1

	# and exchange the procs
	rename ::tk_getOpenFile ::_tk_getOpenFile ;# The way back
	proc ::tk_getOpenFile {args} {
		return [eval ::tk::dialog::file:: open $args]
	}

	rename ::tk_getSaveFile ::_tk_getSaveFile ;# The way back
	proc ::tk_getSaveFile {args} {
		return [eval ::tk::dialog::file:: save $args]
	}

	#
	# tk_chooseDirectory
	#

	option add  *__tk_choosedir.icons.canvas.background white

	# hot patch file choosedir.tcl,v 1.19
	set body [split [info body ::tk::dialog::file::chooseDir::] "\n"]
	set changeA [list "\t# HE: Change the requester size to fit on pda" "\twindowFit \$w" {}]
	set changeB [list "\t# HE: To make the dialog window transient creates a title bar?!" "\t# (at least in etcl-8.4.12-pl7 and etcl-8.4.12-pl8)" "#[lindex $body 44]" "#[lindex $body 45]" "#[lindex $body 46]"]
	set body1 [join [concat [lrange $body 0 43] $changeB [lrange $body 47 end-23] $changeA [lrange $body end-22 end]] "\n"]
	proc ::tk::dialog::file::chooseDir:: {args} $body1

	set body [split [info body ::tk::dialog::file::chooseDir::OkCmd] "\n"]
	set changeA [list "\tset text \[eval file join \[file split \[string trim \$text\]\]\]"]
	set body1 [join [concat [lrange $body 0 26] $changeA [lrange $body 28 end]] "\n"]
	proc ::tk::dialog::file::chooseDir::OkCmd {w} $body1

	# and exchange the procs
	rename ::tk_chooseDirectory ::_tk_chooseDirectory
	proc ::tk_chooseDirectory {args} {
		return [eval ::tk::dialog::file::chooseDir:: $args]
	}

	#
	# bgerror
	#

	# hot patch file bgerror.tcl,v 1.31
	set body [info body ::tk::dialog::error::bgerror]
	regsub -all -- {set messageFont\s\{Times -18\}} $body "set messageFont\tsystem" body1
	regsub -all -- {-setgrid true} $body1 "" body1
	regsub -all -- {-padx 10} $body1 {-padx 2} body1
	regsub -all -- {-sticky ew} $body1 {-sticky nsew} body1
	proc ::tk::dialog::error::bgerror err $body1

	# ChangeA helps us to react of  changing the locale. The use of 'option add *ErrorDialog.function.text ...' in the original script mixed up the locale if the locale changed at script livetime
	set body [split [info body ::tk::dialog::error::Details] "\n"]
	set changeA [list "set caption \[mc \"Save To Log\"\]"]
	set changeB [list "\twindowFit \$w"]
	set body1 [join [concat [lrange $body 0 1] $changeA [lrange $body 3 end] $changeB] "\n"]
	proc ::tk::dialog::error::Details {} $body1

	# some german locale are to long for the small screen
	namespace eval ::tk::dialog::error:: {
		::msgcat::mcset de "Skip Messages" "Weitere Nachrichten\n\u00fcberspringen"
		::msgcat::mcset de "Save To Log" "In Protokoll\nspeichern"
	}

# The next part is a replacement for the part above Unix colorchooser based on colorChooser for pocketPC/etcl. Needs version B of pkgIndex.tcl

        #
	# tk_chooseColor
	#
	# alternative color dialog
	rename ::tk_chooseColor ::_tk_chooseColor
	proc ::tk_chooseColor {args} {
		return [eval ::he::dialog::colordialog $args]
	}

 }

 package provide he-dialog 0.5
