#############################
#
#          SoloCartes
#
# Copyright 2008 Newmagic
#
#    This file is part of SoloCartes.
#
#    You can redistribute and/or modify
#    this software under the terms of the
#    Creative Commons  Attribution-NonCommercial-ShareAlike 3.0 Legal Code
#
#    See COPYING file(s) join to the distribution and/or
#    http://creativecommons.org/licenses/by-nc-sa/3.0/legalcode
#
#############################

global PARAM

set PARAM(rep) [info script]
set PARAM(rep) [file dirname $PARAM(rep)]
cd $PARAM(rep)

source "SoloCartes_initJeux.tcl"

global nbCartesDistrib
set nbCartesDistrib 1

global lignes
set lignes(indligne) [list]

global nbLignes
set nbLignes 7

global LISTE_VARS_OPTIONS_JEU
set LISTE_VARS_OPTIONS_JEU [list nbCartesDistrib nbLignes]

global LISTE_VARS_SAUV_PARTIE
set LISTE_VARS_SAUV_PARTIE [list paquet lignes nbLignes nbPassagesPaquet indDerniereCarteDistribuee nbCartes nbCartesDistrib]

global jeuCourant
set jeuCourant Pyramide
chargerOptionsJeu

array set imagesFaces [list]


global paquet

global nbPassagesPaquet
set nbPassagesPaquet 0

global indCarte1
set indCarte1 ""

proc selectionnerCarte1 {indCarte} {
  global indCarte1
  global imgCartes

  deselectionnerCarte1 ;# au cas o
  set indCarte1 $indCarte
  set liste [.frmJeu.cnv coords $imgCartes($indCarte)]
  set x_carte [lindex $liste 0]
  set y_carte [lindex $liste 1]
  tracerRectangleCarte "carte1" $x_carte $y_carte
  .frmJeu.cnv raise $imgCartes($indCarte)
}

proc deselectionnerCarte1 {} {
  global indCarte1

  set indCarte1 ""
  catch {.frmJeu.cnv delete "carte1"}
}

proc attraperCarte {indCarte x y} {
  global imgCartes
  global paquet
  global lignes
  global PAQUET_POURC_X
  global PAQUET_POURC_Y
  global largImages
  global indDerniereCarteDistribuee
  global nbCartes
  global nbCartesDistrib
  global nbPassagesPaquet
  global indCarte1
  global txt

  if {$indCarte1 == $indCarte} {
    # On annule la slection :
    deselectionnerCarte1
  } else {
    set liste [.frmJeu.cnv coords $imgCartes($indCarte)]
    set x_carte [lindex $liste 0]
    set y_carte [lindex $liste 1]
    if {$paquet($indCarte,distribuee)} {
      if {[estLibre $indCarte]} {
        if {[valeurCarte $indCarte] == 13} {
          # On peut l'enlever
          enleverCarte $indCarte
          deselectionnerCarte1
          gagner 10
        } else {
          # Voyons si une autre a t slectionne :
          if {$indCarte1 != ""} {
            # Voyons si c'est ok :
            set somme [expr {[valeurCarte $indCarte] + [valeurCarte $indCarte1]}]
            if {$somme == 13} {
              # On peut les enlever toutes les deux :
              enleverCarte $indCarte1
              enleverCarte $indCarte
              deselectionnerCarte1
              gagner 10
            }
          } else {
            # On choisit celle-l :
            selectionnerCarte1 $indCarte
          }
        }
  if {[termine]} {
    verifierScore
    incrementerStats "$txt(STAT_NB_GAGNE)"
    proposerRejouer
  }
      } ;# On ne fait rien
    } else {
      if {[pourcCoordX $x_carte] == $PAQUET_POURC_X && [pourcCoordY $y_carte] == $PAQUET_POURC_Y} {
        # clic sur paquet
#        if {$indCarte1 == $indDerniereCarteDistribuee} {
          deselectionnerCarte1
#        }
memoriserCoupAnnuler 1
        distribuer
      }
    }
  }
}

proc estLibre {indCarte} {
  global lignes
  global nbLignes
  global paquet
  global indDerniereCarteDistribuee
  global indCarte1

  set continuer true
  set trouve false
  set indLigne 1
  if {$paquet($indCarte) != ""} {
    # La carte n'a pas encore t enleve
    if {$indCarte == $indDerniereCarteDistribuee} {
      # il s'agit de la premire du paquet :
      set trouve true
    } else {
      while {$continuer} {
        if {[lsearch $lignes($indLigne) $indCarte] >= 0} {
          set continuer false
          set trouve true
        }
        if {$continuer} {
          incr indLigne
          if {$indLigne > $nbLignes} {
            set continuer false
          }
        }
      }
      if {$trouve} {
        # La carte est sur la ligne $indLigne
        # si c'est la dernire ligne, alors ok
        # sinon, il faut regarder "dessous"
        set trouve false
        if {$indLigne == $nbLignes} {
          set trouve true
        } else {
          # La carte est libre si celles situes dessous ont t supprimes
          # cad celle de mme rang r et celle de rang r+1 (dans la ligne suivante)
          set rang [lsearch $lignes($indLigne) $indCarte]
          if {$rang >= 0} {
            set carteSous1 [lindex $lignes([expr {$indLigne + 1}]) $rang]
            set carteSous2 [lindex $lignes([expr {$indLigne + 1}]) [expr {$rang + 1}]]
            if {[valeurCarte $indCarte] == 13} {
              # cas particulier des rois : ils doivent tre strictement libres :
              if {$paquet($carteSous1) == "" && $paquet($carteSous2) == ""} {
                set trouve true
              }
            } else {
              if {($paquet($carteSous1) == "" || $carteSous1 == $indCarte1) && ($paquet($carteSous2) == "" || $carteSous2 == $indCarte1)} {
                # Si une des deux cartes n'est pas encore partie, c'est qu'elle est la carte choisie en 1
                set trouve true
              }
            }
          }
        }
      }
    }
  }
  return $trouve
}


proc enleverCarte {indCarte} {
  global imgCartes
  global paquet
  global indDerniereCarteDistribuee

  catch {.frmJeu.cnv delete $imgCartes($indCarte)}
  set paquet($indCarte) ""
  if {$indCarte == $indDerniereCarteDistribuee} {
    set indDerniereCarteDistribuee [cartePrecDistribuee $indCarte]
  }
effacerCoupAnnuler
}

proc distribuer {{jusqua ""}} {
  global indDerniereCarteDistribuee
  global paquet
  global nbCartesDistrib
  global nbCartes
  global PAQUET_POURC_X
  global PAQUET_POURC_Y
  global largImages
  global imgCartes
  
  if {$jusqua == ""} {
    set jusqua $nbCartes
  }
  if {$indDerniereCarteDistribuee <= 0} {
    set indDerniereCarteDistribuee 1 ;# on passe direct  la 1
  } else {
    set i 1
    set prec $indDerniereCarteDistribuee
    #incr prec -1
    set prec [cartePrecDistribuee $prec]
    while {$i < $nbCartesDistrib && $prec > 0} {
      .frmJeu.cnv coords $imgCartes($prec) [list [coordX [expr {2 * $PAQUET_POURC_X + $largImages}]] [coordY $PAQUET_POURC_Y]]
      incr i
      incr prec -1
      set prec [cartePrecDistribuee $prec]
    }
  }
  for {set i 0} {$i < $nbCartesDistrib} {incr i} {
    set continuer true
    while {$continuer} {
      if {$indDerniereCarteDistribuee <= $jusqua} {
        if {(! $paquet($indDerniereCarteDistribuee,distribuee)) && $paquet($indDerniereCarteDistribuee) != ""} {
          set indCarte $indDerniereCarteDistribuee
          set paquet($indCarte,faceEnHaut) false
          deplacerCarte $indCarte [coordX [expr {2 * $PAQUET_POURC_X + $largImages + 3 * $i}]] [coordY $PAQUET_POURC_Y]
          retournerCarte $indCarte
          set paquet($indCarte,distribuee) true
          set continuer false
        } else {
          incr indDerniereCarteDistribuee
        }
      } else {
        set indDerniereCarteDistribuee $jusqua
        set continuer false
      }
    }
  }
}


proc bindingsCarte {indCarte} {
  global imgCartes

  .frmJeu.cnv bind $imgCartes($indCarte) <ButtonPress-1> "attraperCarte $indCarte %X %Y"

  .frmJeu.cnv bind $imgCartes($indCarte) <Double-ButtonPress-1> "attraperCarte $indCarte %X %Y"

}


proc rempilerPaquet {} {
  global indDerniereCarteDistribuee
  global paquet
  global colonnes
  global nbColonnes
  global depots
  global PAQUET_POURC_X
  global PAQUET_POURC_Y
  global nbCartes
  global nbPassagesPaquet
  global typeScore
  global nbCartesDistrib

  set continuer true
  # on regarde d'abord s'il ne resterait pas des cartes  distribuer...
  set i $indDerniereCarteDistribuee
  set resteCartes false
  set paquetContientCartes false
  while {$continuer} {
    if {$i <= $nbCartes && $i >= 0} {
      set paquetContientCartes true
      if {(! $paquet($i,distribuee)) && $paquet($i) != ""} {
        set continuer false
        set resteCartes true
      } else {
        incr i
      }
    } else {
      set continuer false
    }
  }
  if {$paquetContientCartes && ! $resteCartes} {
    #msgBox "ok, il ne reste plus de carte !"
    # Voyons maintenant si on le peut :
    incr nbPassagesPaquet
    set reglesOkDistribuer true
#    if {$typeScore == "vegas"} {
#      if {$nbPassagesPaquet >= $nbCartesDistrib} {
#        set reglesOkDistribuer false
#      }
#    } else {
      perdre 5
#    }
    if {$reglesOkDistribuer} {
effacerCoupAnnuler
      for {set indCarte $nbCartes} {$indCarte >= 1} {incr indCarte -1} {
        if {(![carteSurLigne $indCarte]) && $paquet($indCarte) != ""} {
          set paquet($indCarte,distribuee) false
          deplacerCarte $indCarte [coordX $PAQUET_POURC_X] [coordY $PAQUET_POURC_Y]
          .frmJeu.cnv raise Carte$indCarte
          retournerCarte $indCarte
        }
      }
      set indDerniereCarteDistribuee -1
    }
  }
}

# Dans ce jeu, une carte est sur une ligne si elle est plus basse que le paquet ET qu'elle est visible (cad avec une valeur)
proc carteSurLigne {indCarte} {
  global lignes
  global nbLignes
  global paquet

  set continuer true
  set trouve false
  set indLigne 1
  if {$paquet($indCarte) != ""} {
    # La carte n'a pas encore t enleve
    while {$continuer} {
      if {[lsearch $lignes($indLigne) $indCarte] >= 0} {
        set continuer false
        set trouve true
      }
      if {$continuer} {
        incr indLigne
        if {$indLigne > $nbLignes} {
          set continuer false
        }
      }
    }
  }
  return $trouve
}

proc cartePrecDistribuee {indCarte} {
  global paquet

  set continuer true
  set i $indCarte
  while {$continuer} {
    if {[carteSurLigne $i] || $paquet($i) == ""} {
      incr i -1
      if {$i <= 0} {
        set i -1
        set continuer false
      }
    } else {
      set continuer false
    }
  }
  return $i
}

proc initLignes {nb} {
  global nbLignes
  global lignes
  global hautImages
  global largImages
  global PAQUET_POURC_Y

  unset lignes
  set nbLignes $nb

  for {set i 1} {$i <= $nbLignes} {incr i} {
    set lignes($i) [list]
  }
}

proc distribuerCartes {} {
  global nbLignes
  global indDerniereCarteDistribuee

  set indCarte 1
  set indLigne 1
  set continuer true
  while {$indLigne <= $nbLignes} {
    # Pour chaque ligne, on doit poser indLigne cartes
    for {set i 1} {$i <= $indLigne} {incr i} {
      distribuerCarteSurLigne $indCarte $indLigne ;# true
      retournerCarte $indCarte
      incr indCarte
    }
    incr indLigne
  }
  set indDerniereCarteDistribuee $indCarte
  incr indDerniereCarteDistribuee -1
}

proc distribuerCarteSurLigne {indCarte indLigne {rang ""} {avecAnimation false}} {
  global lignes
  global paquet
  global PAQUET_POURC_X
  global PAQUET_POURC_Y
  global hautImages
  global largImages

  set espaceEntreCartes 1
  if {$rang == ""} {
    set rang [llength $lignes($indLigne)]
    lappend lignes($indLigne) $indCarte
  }
  # On doit poser sur une ligne un nombre de carte correspondant  son rang
  # => ici, la ligne comportera indLigne cartes au final
  set nbCartesMaxSurLigne $indLigne
  # On en dduit l'endroit de la premire carte de la ligne :
  set pourcXPremCarteLigne [expr { 50 - (((0.0 + $nbCartesMaxSurLigne) / 2) * $largImages)  - ((((0.0 + $nbCartesMaxSurLigne) / 2) - 1) * $espaceEntreCartes) }]
  # on en dduit alors l'emplacement de la carte courante :
  set xPourc [expr { $pourcXPremCarteLigne + ($rang * $largImages) + (($rang - 1) * $espaceEntreCartes) }]
  set yPourc [expr { $PAQUET_POURC_Y + $hautImages + ($hautImages / 2) * ($indLigne - 1) }]
  deplacerCarte $indCarte [coordX $xPourc] [coordY $yPourc] $avecAnimation
  set paquet($indCarte,distribuee) true
}

proc termine {} {
  global lignes
  global nbCartes
  global paquet

  set indCarteSommet [lindex $lignes(1) 0]
  if {$paquet($indCarteSommet) == ""} {
effacerCoupAnnuler
    return true
  } else {
    return false
  }
}


proc initScoresStats {} {
global jeuCourant
  global nbLignes
  global nbCartesDistrib
  global typeScore
global titreScores
  global REP_HIGHSCORES
  global REP_STATS
  global txt

set titreScores "$txt($jeuCourant\,NOM) - $nbLignes lignes - $nbCartesDistrib "
if {$nbCartesDistrib > 1} {
  append titreScores "$txt(TXT_CARTES)"
} else {
  append titreScores "$txt(TXT_CARTE)"
}
set nomFicScores "$jeuCourant\_$nbLignes\_$nbCartesDistrib"
  chargerHighScores [file join $REP_HIGHSCORES "$nomFicScores\.txt"]
  chargerStats [file join $REP_STATS "$jeuCourant\.txt"]
}

proc majAfficheJeu {} {
  global lignes
  global nbLignes
  global paquet
  global nbCartes
  global indDerniereCarteDistribuee
  global nbCartesDistrib
  global PAQUET_POURC_X
  global PAQUET_POURC_Y
  global hautImages
  global nbPassagesPaquet

  initScoresStats
  initAffichage
  set dernDistrib $indDerniereCarteDistribuee
#msgBox "$dernDistrib"

  set PAQUET_POURC_X 5
  set PAQUET_POURC_Y 5
  tracerRectangleCarte "paquet" [coordX $PAQUET_POURC_X] [coordY $PAQUET_POURC_Y]
 .frmJeu.cnv bind paquet <ButtonPress-1> "rempilerPaquet"
  for {set i $nbCartes} {$i >= 1} {incr i -1} {
#    if {$paquet($i) != ""} {
      placerCarte $i $PAQUET_POURC_X $PAQUET_POURC_Y [expr {! $paquet($i,faceEnHaut)}]
#    }
  }

  #  initColonnes $nbColonnes
  for {set i 1} {$i <= $nbCartes} {incr i} {
    set paquet($i,distribuee) false
  }
  set indDerniereCarteDistribuee 0
  for {set i 1} {$i <= $nbLignes} {incr i} {
    set rang 0
    #msgBox "$i : $colonnes($i,listeCartes)"
    foreach indCarte $lignes($i) {
      if {$paquet($indCarte) != ""} {
        set paquet($indCarte,distribuee) true
        set faceEnHaut($indCarte) $paquet($indCarte,faceEnHaut)
        #    placerCarte $indCarte 110 110 true
        distribuerCarteSurLigne $indCarte $i $rang
        set paquet($indCarte,faceEnHaut) $faceEnHaut($indCarte)
        montrerCarte $indCarte $paquet($indCarte,faceEnHaut)
      }
      incr rang
      incr indDerniereCarteDistribuee
    }
  }
  for {set i 1} {$i <= $nbCartes} {incr i} {
    if {$paquet($i) == ""} {
      enleverCarte $i
    }
  }
  
  # maintenant, on distribue toutes les cartes jusqu' la derniere distribue :
  set indDerniereCarteDistribuee -1
  while {$dernDistrib > $indDerniereCarteDistribuee} {
    distribuer $dernDistrib
  }
  update
}

proc commencerPartie {} {
  global joueurs
  global SCORE_DE_DEPART
  global nbCartesDistrib
  global nbLignes
global jeuCourant
  global titreScores
  global txt
  
  initPartie $jeuCourant
  initScoresStats
  initAffichage
  melangerPaquet
  placerPaquet 5 5
  initLignes $nbLignes
  distribuerCartes
  majAfficheScore
  afficherFrame frmJeu
  incrementerStats "$txt(STAT_NB_PARTIES)"
}

global lanceAuto
if {$lanceAuto} {
commencerPartie
}