#############################
#
#          SoloCartes
#
# Copyright 2008 Newmagic
#
#    This file is part of SoloCartes.
#
#    You can redistribute and/or modify
#    this software under the terms of the
#    Creative Commons  Attribution-NonCommercial-ShareAlike 3.0 Legal Code
#
#    See COPYING file(s) join to the distribution and/or
#    http://creativecommons.org/licenses/by-nc-sa/3.0/legalcode
#
#############################

global PARAM

set PARAM(rep) [info script]
set PARAM(rep) [file dirname $PARAM(rep)]
cd $PARAM(rep)

source "SoloCartes_initJeux.tcl"

global nbCartesDistrib
set nbCartesDistrib 3

global familleCartes
set familleCartes "P"

global LISTE_VARS_OPTIONS_JEU
set LISTE_VARS_OPTIONS_JEU [list nbCartesDistrib familleCartes]

global LISTE_VARS_SAUV_PARTIE
set LISTE_VARS_SAUV_PARTIE [list paquet colonnes nbColonnes nbCartes nbCartesDistrib familleCartes]

global jeuCourant
set jeuCourant "ToursHanoi"
chargerOptionsJeu

array set imagesFaces [list]


proc colSousXY {x y} {
  return [colSousPourcXY [pourcCoordX $x] [pourcCoordY $y]]
}

proc colSousPourcXY {pourcX pourcY} {
  global nbColonnes
  global colonnes
  global largImages
  global PAQUET_POURC_Y
  global hautImages

    set continuer true
    set i 0
    set minCarte $pourcX
#    set maxCarte [expr {$pourcX + [pourcCoordX $largImages]}]
    set maxCarte [expr {$pourcX + $largImages}]
    set milieuCarte [expr {$minCarte + (($maxCarte - $minCarte) / 2)}]
    set colDroite -1
    set colGauche -1
    set distGauche -1
    set distDroite -1

#msgBox "$pourcX [pourcCoordX $largImages] => $milieuCarte"
    while {$continuer} {
      incr i
      if {$i <= $nbColonnes} {
        set minCol $colonnes($i,posX)
        if {$minCol > $maxCarte} {
          # ca sert  rien d'aller + loin
          set continuer false
        }
        if {$continuer} {
#          set maxCol [expr {$minCol + [pourcCoordX $largImages]}]
          set maxCol [expr {$minCol + $largImages}]
          if {$minCarte >= $minCol && $minCarte <= $maxCol} {
            set colGauche $i
#            set distGauche [expr {$maxCol - $minCarte}]
            set distGauche [expr {$maxCarte - $minCol}]
          }
          if {$maxCarte >= $minCol && $maxCarte <= $maxCol} {
            set colDroite $i
#            set distDroite [expr {$maxCarte - $minCol}]
            set distDroite [expr {$maxCol - $minCarte}]
          }
        }
      } else {
        set continuer false
      }
    }
    set indCol $colGauche
    if {$colGauche > 0 && $colDroite > 0} {
      # on regarde le plus prs :
      if {$distGauche > $distDroite} {
        set indCol $colDroite
      }
    }
    if {$indCol == -1} {
      set indCol $colDroite
    }
    return $indCol
}

global paquet

global nbColonnes
set nbColonnes 0

global colonnes
set colonnes(ind,posX) pourc
set colonnes(ind,listeCartes) [list]

proc attraperCarte {indCarte x y} {
  global indCarteDragguee
  global indCarteDraggueeTmp
  global diffX
  global diffY
  global imgCartes
  global paquet
  global x_initDrag
  global y_initDrag
  global colonnes
  global PAQUET_POURC_X
  global PAQUET_POURC_Y
  global largImages
  global nbCartes
  global nbCartesDistrib

  set liste [.frmJeu.cnv coords $imgCartes($indCarte)]
  set x_carte [lindex $liste 0]
  set y_carte [lindex $liste 1]
        set indCarteDraggueeTmp $indCarte
        .frmJeu.cnv raise Carte$indCarteDraggueeTmp
        set x_initDrag $x_carte
        set y_initDrag $y_carte
        set diffX [expr {$x - $x_initDrag}]
        set diffY [expr {$y - $y_initDrag}]
}


proc lacherCarte {} {
  global indCarteDragguee
  global indCarteDraggueeTmp
  global imgCartes
  global diffX
  global diffY
  global x_initDrag
  global y_initDrag
  global colonnes
  global paquet
  global nbColonnes
  global nbCartes
global joueurs
global txt

  set diffX 0
  set diffY 0
  if {$indCarteDraggueeTmp > 0} {
    set indCarteDragguee $indCarteDraggueeTmp
    set deplaceOk false
    set indCarte $indCarteDragguee
    set liste [.frmJeu.cnv coords $imgCartes($indCarte)]
    set x [lindex $liste 0]
    set y [lindex $liste 1]
    set indCol [colSousXY $x $y]
    set indAncienneCol [colSousXY $x_initDrag $y_initDrag]

    if {$indCol > 0 && $indCol != $indAncienneCol} {
      # rgles
      set reglesOk false
      set nbCartesSurCol [llength $colonnes($indCol,listeCartes)]
      if {$nbCartesSurCol > 0} {
        set derniereCarteCol [lindex $colonnes($indCol,listeCartes) end]
        if {[differenceCartes $derniereCarteCol $indCarte] >= 1} {
          # >= 1 => ok
          set reglesOk true
        }
      } else {
          # pas de carte => ok
          set reglesOk true
      }
      if {$reglesOk} {
        if {$indAncienneCol > 0} {
memoriserCoupAnnuler 1
          set indDansAncienneCol [lsearch $colonnes($indAncienneCol,listeCartes) $indCarte]
          if {$indDansAncienneCol >= 0} {
            distribuerCarteSurColonne $indCarteDragguee $indCol
            enleverDerniereCarteCol $indAncienneCol
          }
          set deplaceOk true
          perdre 1
          if {[termine]} {
            update idletasks
set nbCoupsMin  [expr {int(pow(2,$nbCartes)) - 1}]
#            gagner [expr {100 + int(pow(2,$nbCartes)) - 1}]
            gagner [expr {2 * $nbCoupsMin}]
            verifierScore
            incrementerStats "$txt(STAT_NB_GAGNE)"
            proposerRejouer
          }
        }
      }
    }
    if {!$deplaceOk} {
      # on la replace o elle tait
      deplacerCarteDraguee $x_initDrag $y_initDrag
    } ;# sinon, dj fait !
  }
  set indCarteDragguee -1
  set indCarteDraggueeTmp -1
}

proc deplacerCarteDraguee {x y} {
  global indCarteDragguee
  global indCarteDraggueeTmp
  global x_initDrag
  global y_initDrag
  global colonnes
  global paquet

  if {$indCarteDragguee > 0} {
    set indAncienneCol [colSousXY $x_initDrag $y_initDrag]
    set indDerniereCarteAncienneCol [lindex $colonnes($indAncienneCol,listeCartes) end]
    if {$indDerniereCarteAncienneCol == $indCarteDragguee} {
      deplacerCarte $indCarteDragguee $x $y
    } else {
      # Elle reste l (et on remet "par-dessus" les suivantes :
      set indDansCol [lsearch $colonnes($indAncienneCol,listeCartes) $indCarteDragguee]
      for {set i $indDansCol} {$i < [llength $colonnes($indAncienneCol,listeCartes)]} {incr i} {
        .frmJeu.cnv raise "Carte[lindex $colonnes($indAncienneCol,listeCartes) $i]"
      }
      set indCarteDragguee -1
      set indCarteDraggueeTmp -1
    }
  } else {
    set diffX [expr {$x - $x_initDrag}]
    if {$diffX < 0} {set diffX [expr {0 - $diffX}]}
    set diffY [expr {$y - $y_initDrag}]
    if {$diffY < 0} {set diffY [expr {0 - $diffY}]}
    set diffActive 50
    #msgBox "$diffX $diffY"
    if {$diffX > $diffActive || $diffY > $diffActive} {
      set indCarteDragguee $indCarteDraggueeTmp
    }
  }
}


proc bindingsCarte {indCarte} {
  global imgCartes

  .frmJeu.cnv bind $imgCartes($indCarte) <ButtonPress-1> "attraperCarte $indCarte %X %Y"
  .frmJeu.cnv bind $imgCartes($indCarte) <ButtonRelease-1> "lacherCarte"
  .frmJeu.cnv bind $imgCartes($indCarte) <Motion> {deplacerCarteDraguee %X %Y}

#  .frmJeu.cnv bind $imgCartes($indCarte) <Double-ButtonPress-1> "chercherDepotPourCarte $indCarte %X %Y"

}

proc carteSurCol {indCarte} {
  global colonnes
  global nbColonnes

  set continuer true
  set trouve false
  set indCol 1
  while {$continuer} {
    if {[lsearch $colonnes($indCol,listeCartes) $indCarte] >= 0} {
      set continuer false
      set trouve true
    }
    if {$continuer} {
      incr indCol
      if {$indCol > $nbColonnes} {
        set continuer false
      }
    }
  }
  return $trouve
}

proc initColonnes {nb} {
  global nbColonnes
  global colonnes
  global hautImages
  global largImages
  global PAQUET_POURC_Y

  unset colonnes
  set nbColonnes $nb
  set espaceEntreCol [expr {(100 - ($nbColonnes * $largImages)) / ($nbColonnes + 1)}]

  for {set i 1} {$i <= $nbColonnes} {incr i} {
    set colonnes($i,listeCartes) [list]
    set colonnes($i,posX) [expr {($espaceEntreCol * $i) + ($largImages * ($i - 1))}]
    tracerRectangleCarte "col$i" [coordX $colonnes($i,posX)] [coordY $PAQUET_POURC_Y]
  }
}

proc distribuerCartes {} {
  global nbCartes

  for {set i $nbCartes} {$i >= 1} {incr i -1} {
    distribuerCarteSurColonne $i 1 ;# true
    retournerCarte $i
  }
#  gagner [expr {$nbCartes * $nbCartes}]
}

proc deplacerCarteSurColonne {indCarte indColonne rang {avecAnimation false}} {
  global colonnes
  global paquet
  global PAQUET_POURC_Y
  global hautImages

  set yPourc [expr {$PAQUET_POURC_Y - 3 * $rang}]
  deplacerCarte $indCarte [coordX $colonnes($indColonne,posX)] [coordY $yPourc] $avecAnimation
}

proc termine {} {
  global colonnes
  global nbColonnes
  global nbCartes

  if {[llength $colonnes($nbColonnes,listeCartes)] == $nbCartes} {
effacerCoupAnnuler
    return true
  } else {
    return false
  }
}


proc initScoresStats {} {
global jeuCourant
  global nbCartesDistrib
global titreScores
  global REP_HIGHSCORES
  global REP_STATS
  global txt

set titreScores "$txt($jeuCourant\,NOM) - $nbCartesDistrib $txt(TXT_CARTES)"
  chargerHighScores [file join $REP_HIGHSCORES "$jeuCourant\_$nbCartesDistrib\.txt"]
  chargerStats [file join $REP_STATS "$jeuCourant\.txt"]
}

proc majAfficheJeu {} {
  global colonnes
  global nbColonnes
  global paquet
  global nbCartes
  global nbCartesDistrib
  global PAQUET_POURC_X
  global PAQUET_POURC_Y
  global hautImages
global jeuCourant

  initScoresStats
  initAffichage

  set PAQUET_POURC_X 150
  set PAQUET_POURC_Y [expr {45 - int(($hautImages - 3 * ($nbCartes - 1)) / 2)}]
#  tracerRectangleCarte "paquet" [coordX $PAQUET_POURC_X] [coordY $PAQUET_POURC_Y]
# .frmJeu.cnv bind paquet <ButtonPress-1> "rempilerPaquet"
#  for {set i $nbCartes} {$i >= 1} {incr i -1} {
#    placerCarte $i $PAQUET_POURC_X $PAQUET_POURC_Y [expr {! $paquet($i,faceEnHaut)}]
#  }

  #  initColonnes $nbColonnes
  for {set i 1} {$i <= $nbCartes} {incr i} {
    placerCarte $i $PAQUET_POURC_X $PAQUET_POURC_Y [expr {! $paquet($i,faceEnHaut)}]
    set paquet($i,distribuee) false
  }
  for {set i 1} {$i <= $nbColonnes} {incr i} {
    tracerRectangleCarte "col$i" [coordX $colonnes($i,posX)] [coordY $PAQUET_POURC_Y]
    set rang 0
    #msgBox "$i : $colonnes($i,listeCartes)"
    foreach indCarte $colonnes($i,listeCartes) {
      set paquet($indCarte,distribuee) true
      set faceEnHaut($indCarte) $paquet($indCarte,faceEnHaut) 
      #    placerCarte $indCarte 110 110 true
      deplacerCarteSurColonne $indCarte $i $rang
      set paquet($indCarte,faceEnHaut) $faceEnHaut($indCarte)
      montrerCarte $indCarte $paquet($indCarte,faceEnHaut)
      incr rang
    }
  }
  update
}

proc commencerPartie {} {
  global joueurs
  global SCORE_DE_DEPART
  global nbCartesDistrib
global jeuCourant
global nbCartes
global paquet
global dosCartes
global hautImages
global familleCartes
global txt

  initPartie $jeuCourant
  initScoresStats
  initAffichage
#  melangerPaquet
  set nbCartes 0
#  set paquet(imgDos) [getImageCarte [file join "Img" "carteDos$dosCartes\.png"]]
  majDosCartes
  set dosTmp $paquet(imgDos)
  unset paquet
  set paquet(imgDos) $dosTmp
  for {set i 1} {$i <= $nbCartesDistrib} {incr i} {
    incr nbCartes
    set paquet($nbCartes,faceEnHaut) false
    set valeur $i
    if {$i == 1} {set valeur "A"}
    if {$i == 11} {set valeur "V"}
    if {$i == 12} {set valeur "D"}
    if {$i == 13} {set valeur "R"}
    set paquet($nbCartes) "$valeur$familleCartes"
    set paquet($nbCartes,distribuee) false
  }
  placerPaquet 150 [expr {45 - int(($hautImages - 3 * ($nbCartes - 1)) / 2)}]
  initColonnes 3
  distribuerCartes
  majAfficheScore
  afficherFrame frmJeu
  incrementerStats "$txt(STAT_NB_PARTIES)"
}

proc modifierFamille {nouvFamille} {
  global familleCartes
  global nbCartes
  global paquet
  
  set familleCartes $nouvFamille
  for {set i 1} {$i <= $nbCartes} {incr i} {
    set valeur $i
    if {$i == 1} {set valeur "A"}
    if {$i == 11} {set valeur "V"}
    if {$i == 12} {set valeur "D"}
    if {$i == 13} {set valeur "R"}
    set paquet($i) "$valeur$familleCartes"
    montrerCarte $i
  }
}

global lanceAuto
if {$lanceAuto} {
commencerPartie
}